### 简介
    本项目旨在提供一些方便于工作中git操作命令
    目前仅仅提供了两个命令，后续大家可以继续补充

### 使用方法
    1、自己项目clone到本地，例如，放在如下目录下 /home/user/git-tools/
    2、然后为命令配置下别名，即可方便后续使用
    - 用vim编辑器打开 ~/.bash_profile 文件, 如果文件不存在直接新建一个即可（windows下需要在git-bash工具下打开）
    - 加入如下别名命令，保存退出 (具体命令的别名，可以按个人喜好进行调整)
    alias gm='sh /home/user/git-tools/git_merge_branch.sh'
    alias gmr='sh /home/user/git-tools/git_submit_merge_request.sh'
    - 初次编辑后，需要运行下 source ~/.bash_profile 方可使得命令立即生效

### 详解

#### git_merge_branch.sh [target_branch] [need_push_after_merge]
    提供了方便的分支合并以及向远端仓库推送的命令集合，工作中常见的场景为：提测阶段，需要将开发分支合并到testing分支，然后进行QA环境的部署
##### 参数
- targe_branch
    待合并的分支名称

- need_push_after_merge  0-否  1-是
    是否需要在合并后，将目标分支推送到远端仓库。默认为0

##### 使用
```
进入要处理项目根目录下，处理好未提交的代码，保证工作区以及暂存区处于干净的状态 
gm testing 1
```

#### git_submit_merge_request.sh [merge_comment]
    当项目发布的时候，为了避免对主干master的污染，向master合并分支的时候，最好将自己的开发分支的commit进行一些合并，这个工具可以方便的实现这点
    原理也很简单：
    - 先从主干master分支切出一个新的分支，命名规则为 当前分支名 + '_merge'
    - 将当前分支合并到该分支上，但使用的命令稍微特殊 git merge --squash 当前开发分支名
    - 将新切出的分支推送到远端，删除掉本地的该分支，然后切换回自己的开发分支

##### 参数
- merge_comment
    对此次合并操作的描述 

##### 使用
```
进入要处理项目根目录下，处理好未提交的代码，保证工作区以及暂存区处于干净的状态 
gmr '**版本代码发布'
```
