#!/usr/bin/env bash
#
target_branch=$1
need_push_after_update=$2

#if [ -z "$target_branch" ] || [ "$target_branch" != "develop" -a "$target_branch" != "master" ]
if [ -z "$target_branch" ]
then
    target_branch="develop"
fi
current_branch=$(git branch | grep '*' | awk '{print $2}')

is_current_branch_in_remote=$(git branch -r | grep "origin/$current_branch" | wc -l)
if [ $is_current_branch_in_remote -eq 0 ]
then
    git push origin $current_branch
fi

git pull origin $current_branch
if [ $? -ne 0 ]
then
    echo "***********************************"
    echo "当前分支 "$current_branch" 拉取失败"
    echo "***********************************"
    exit
else
    echo "==================================="
    echo "当前分支 "$current_branch" 拉取成功"
    echo "==================================="
fi

git push origin $current_branch
if [ $? -ne 0 ]
then
    echo "***********************************"
    echo "当前分支 "$current_branch" 推送失败"
    echo "***********************************"
    exit
else
    echo "==================================="
    echo "当前分支 "$current_branch" 推送成功"
    echo "==================================="
fi

git checkout $target_branch

if [ $? -ne 0 ]
then
    echo "**********************************"
    echo "目标分支 "$target_branch" 切换失败"
    echo "**********************************"
    exit
else
    echo "==================================="
    echo "成功切换到目标分支 "$target_branch
    echo "==================================="
fi

git pull origin $target_branch

if [ $? -ne 0 ]
then
    echo "**********************************"
    echo "目标分支 "$target_branch" 拉取失败"
    echo "**********************************"
    exit
else
    echo "==================================="
    echo "目标分支 "$target_branch" 拉取成功"
    echo "==================================="
fi

git merge $current_branch

if [ $? -ne 0 ]
then
    echo "********"
    echo "合并失败"
    echo "********"
    exit
else
    echo "========"
    echo "合并成功"
    echo "========"
fi

git checkout $current_branch

if [ $need_push_after_update -eq 1 ]
then
    git push origin $target_branch
    if [ $? -ne 0 ]
    then
        echo "**********************************"
        echo "目标分支 "$target_branch" 推送失败"
        echo "**********************************"
    else
        echo "=================================="
        echo "目标分支 "$target_branch" 推送成功"
        echo "=================================="
    fi
fi

echo "===================================="
echo "向目标分支 "$target_branch" 合并完成"
echo "===================================="

